<?php
/**
 * AJAX call handler for offlineVersionBuilder plugin
 *
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Andreas Gohr <andi@splitbrain.org>
 */

//fix for Opera XMLHttpRequests
if(!count($_POST) && $HTTP_RAW_POST_DATA){
  parse_str($HTTP_RAW_POST_DATA, $_POST);
}

if(!defined('DOKU_INC')) define('DOKU_INC',realpath(dirname(__FILE__).'/../../../').'/');
if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');

define("offline_plugin", 1);
$offlineVersionPath = DOKU_PLUGIN.'offlineVersionBuilder/archive/'.date('Y-m-d').'/';

require_once(DOKU_PLUGIN.'offlineVersionBuilder/common.php');
require_once(DOKU_INC.'inc/init.php');
require_once(DOKU_INC.'inc/common.php');
require_once(DOKU_INC.'inc/pageutils.php');
require_once(DOKU_INC.'inc/auth.php');
require_once(DOKU_INC.'inc/search.php');
require_once(DOKU_INC.'inc/html.php');
require_once(DOKU_INC.'inc/template.php');
require_once(DOKU_INC.'inc/actions.php');

//close sesseion
session_write_close();

header('Content-Type: text/plain; charset=utf-8');

//we only work for admins!
if (auth_quickaclcheck($conf['start']) < AUTH_ADMIN){
    die('access denied');
}

//call the requested function
$call = 'ajax_'.$_POST['call'];
if(function_exists($call)){
    $call();
}else{
    print "The called function '".htmlspecialchars($call)."' does not exist!";
}


/**
 * Searches for pages
 *
 * @author Andreas Gohr <andi@splitbrain.org>
 */
function ajax_pagelist(){
    global $conf;
    $data = array();
    search($data,$conf['datadir'],'search_allpages',array());

    foreach($data as $val){
        print $val['id']."\n";
    }
}

/**
 * Index the given page
 *
 * We're doing basicly the same as the real indexer but ignore the
 * last index time here
 */
function ajax_buildOfflinePage(){
    global $conf;
    global $offlineVersionPath;
    global $_POST;

    if(!$_POST['page']){
        print 1;
        exit;
    }

    // keep running
    @ignore_user_abort(true);

    // try to aquire a lock
   /* $lock = $conf['lockdir'].'/_offlineVersionBuilder.lock';
    while(!@mkdir($lock)){
        if(time()-@filemtime($lock) > 60*5){
            // looks like a stale lock - remove it
            @rmdir($lock);
        }else{
            print 'Offline version Buidler is locked.';
            exit;
        }

    }*/

    global $ID, $ACT;
    $ID = $_POST['page'];
    $ACT = 'show';
    $conf['template']='offline';

    ob_start();
    include(template('main.php'));
    $data = ob_get_contents();
    ob_end_clean();

    io_mkdir_p($offlineVersionPath.'images/_extern/');
    io_saveFile($offlineVersionPath.'/'.str_replace(':', '/', $_POST['page']).'.html', $data,$info);

    @rmdir($lock);

    print 1; 
}


//Setup VIM: ex: et ts=4 enc=utf-8 :
?>
