/**
 * Javascript for offlineVersionBuilder manager plugin
 *
 * @author Andreas Gohr <andi@splitbrain.org>
 */

/**
 * Class to hold some values
 */
function plugin_offlineVersionBuilder_class(){
    this.pages = null;
    this.page = null;
    this.sack = null;
    this.done = 1;
    this.count = 0;
}
var pl_si = new plugin_offlineVersionBuilder_class();
pl_si.sack = new sack(DOKU_BASE + 'lib/plugins/offlineVersionBuilder/ajax.php');
pl_si.sack.AjaxFailedAlert = '';
pl_si.sack.encodeURIString = false;

/**
 * Display the loading gif
 */
function plugin_offlineVersionBuilder_throbber(on){
    obj = document.getElementById('pl_si_throbber');
    if(on){
        obj.style.visibility='visible';
    }else{
        obj.style.visibility='hidden';
    }
}

/**
 * Gives textual feedback
 */
function plugin_offlineVersionBuilder_status(text){
    obj = document.getElementById('pl_si_out');
    obj.innerHTML = text;
}


/**
 * Callback. Gets the list of all pages
 */
function plugin_offlineVersionBuilder_cb_pages(){
    data = this.response;
    pl_si.pages = data.split("\n");
    pl_si.count = pl_si.pages.length;
    plugin_offlineVersionBuilder_status(pl_si.pages.length+" pages found");

    pl_si.page = pl_si.pages.shift();
    window.setTimeout("plugin_offlineVersionBuilder_index()",1000);
}

/**
 * Callback. Gets the info if building of a page was successful
 *
 * Calls the next index run.
 */
function plugin_offlineVersionBuilder_cb_index(){
    ok = this.response;
    if(ok == 1){
        pl_si.page = pl_si.pages.shift();
        pl_si.done++;
        // get next one
        window.setTimeout("plugin_offlineVersionBuilder_index()",1000);
    }else{
        plugin_offlineVersionBuilder_status(ok);
        // get next one
        window.setTimeout("plugin_offlineVersionBuilder_index()",5000);
    }
}

/**
 * Starts the indexing of a page.
 */
function plugin_offlineVersionBuilder_index(){
    if(pl_si.page){
        plugin_offlineVersionBuilder_status('indexing '+pl_si.page+' ('+pl_si.done+'/'+pl_si.count+')');
        pl_si.sack.onCompletion = plugin_offlineVersionBuilder_cb_index;
        pl_si.sack.URLString = '';
        pl_si.sack.runAJAX('call=buildOfflinePage&page='+encodeURI(pl_si.page));
    }else{
        plugin_offlineVersionBuilder_status('finished');
        plugin_offlineVersionBuilder_throbber(false);
    }
}

/**
 * Starts the whole index rebuild process
 */
function plugin_offlineVersionBuilder_go(){
    document.getElementById('pl_si_gobtn').style.display = 'none';
    plugin_offlineVersionBuilder_throbber(true);

    plugin_offlineVersionBuilder_status('Finding all pages');
    pl_si.sack.onCompletion = plugin_offlineVersionBuilder_cb_pages;
    pl_si.sack.URLString = '';
    pl_si.sack.runAJAX('call=pagelist');
}

//Setup VIM: ex: et ts=4 enc=utf-8 :
